package dev.boyfailure.quajra.vectorbreakout;

public class Ball {
    
    short ballX = 250;
    short ballY = 300;
    short ballWidth = 7;
    short ballHeight = 7;
    boolean isActive = false;
    byte ballColor = 0;
    
    byte speedX = 5;
    byte speedY = 5;
    
    public Ball(int x, int y, int width, int height, int color, boolean active) {
        this.ballX = (short) x;
        this.ballY = (short) y;
        this.ballWidth = (short) width;
        this.ballHeight = (short) height;
        this.ballColor = (byte) color;
        this.isActive = active;
    }
    
    public void spawnBall(boolean useChancey) {
        if (useChancey) {
            this.ballX += (short) (VectorBreakout.chancey * 3);
            this.ballY += (short) VectorBreakout.chancey;
        }
        VectorBreakout.ballsOnScreen++;
        this.isActive = true;
    }
    
    public void spawnBall(int x, int y) {
        this.ballX = (short) x;
        this.ballY = (short) y;
        VectorBreakout.ballsOnScreen++;
        this.isActive = true;
    }
    
    public void moveBall() {
        this.ballX += this.speedX;
        this.ballY += this.speedY;
        
        this.checkCollision();
    }
    
    public void bounce(byte bounceType) {
        switch(bounceType) {
            case 0:
                this.speedY = (byte) -(this.speedY);
                switch (VectorBreakout.chancey) {
                    case 0: break;
                    case 1: this.speedX++; break;
                    case 2: break;
                    case 3: this.speedX--; break;
                    case 4: break;
                    case 5: this.speedY++;break;
                    case 6: break;
                    case 7: this.speedY--;break;
                    case 8: break;
                    case 9: this.speedY++;speedX++;break;
                    case 10: break;
                    case 11: this.speedY--;speedX--;break;
                    case 12: break;
                    case 13: this.speedY++;speedY++;break;
                    case 14: break;
                    case 15: this.speedY--;speedY--;break;
                }
                break;
            case 1:
                this.speedX = (byte) -(this.speedX);
                break;
            case 2:
                if (this.speedX > 0) {
                    this.speedX = (byte) -(this.speedX);
                }
                else {
                    this.speedX -= 4;
                }
                this.speedY = (byte) -(this.speedY);
                break;
            case 3:
                if (this.speedX < 0) {
                    this.speedX = (byte) -(this.speedX);
                }
                else {
                    this.speedX += 4;
                }
                this.speedY = (byte) -(this.speedY);
                break;
        }
        if (this.speedX < 2 && this.speedX >= 0) {this.speedX = 2;}
        else if (this.speedX > -2 && this.speedX < 0) {this.speedX = -2;}
        else if (this.speedX > 11) {this.speedX -= 3;}  // Slow down if too fast
        if (this.speedY < 4 && this.speedY >= 0) {this.speedY = 4;}
        else if (this.speedY > -4 && this.speedY < 0) {this.speedY = -4;}
        else if (this.speedY > 11) {this.speedY -= 3;} // Slow down if too fast
    }
    
    public void destroyBall() {
        this.isActive = false;
        this.ballX = 32767;
        this.ballY = 32767;
        VectorBreakout.ballsOnScreen--;
        if (VectorBreakout.ballsOnScreen <= 0) {
            VectorBreakout.lives--;
        }
        if (VectorBreakout.lives <= 0) {
            VectorBreakout.gameLose();
        }
    }
    
    // Checks to see if the ball is in contact with bricks, paddles, or walls
    public void checkCollision() {
        
        // Check floor
        if (this.ballY >= VectorBreakout.gameResY) {
            this.destroyBall();
            return;
        }
        // Check ceiling
        else if (this.ballY <= 0) {
            this.bounce((byte) 0);
            this.ballY = 0;
            return;
        }
        
        // Check walls
        if (this.ballX <= 20) {
            this.bounce((byte) 1);
            this.ballX = 22;
            return;
        }
        else if ((this.ballX + this.ballWidth) >= (VectorBreakout.gameResX - 20 - this.ballWidth)) {
            this.bounce((byte) 1);
            this.ballX = (short) (VectorBreakout.gameResX - 25 - this.ballWidth);
            return;
        }
        
        // Check bricks
        if (VectorBreakout.currentLevel != null) {
        for (byte i = 0; i < VectorBreakout.currentLevel.levelBricks.length; i++) {
            if (VectorBreakout.currentLevel.levelBricks[i] != null) {
                if (VectorBreakout.currentLevel.levelBricks[i].brickY <= this.ballY &&
                    VectorBreakout.currentLevel.levelBricks[i].brickY + VectorBreakout.currentLevel.levelBricks[i].brickHeight >= this.ballY + this.ballHeight) {
                    if (VectorBreakout.currentLevel.levelBricks[i].brickX <= this.ballX &&
                        VectorBreakout.currentLevel.levelBricks[i].brickX + VectorBreakout.currentLevel.levelBricks[i].brickWidth >= this.ballX + this.ballWidth) {
                        VectorBreakout.currentLevel.levelBricks[i].breakBrick();
                        this.bounce((byte) 0);
                        return;
                    }
                }
            }
        }
        }
        
        // Check paddles
        for (byte i = 0; i < VectorBreakout.currentPaddles.length; i++) {
            if (VectorBreakout.currentPaddles[i] != null) {
                if (VectorBreakout.currentPaddles[i].paddleY <= this.ballY &&
                    VectorBreakout.currentPaddles[i].paddleY + VectorBreakout.currentPaddles[i].paddleHeight >= this.ballY + this.ballHeight) {
                    if (VectorBreakout.currentPaddles[i].paddleX <= this.ballX &&
                        VectorBreakout.currentPaddles[i].paddleX + VectorBreakout.currentPaddles[i].paddleWidth >= this.ballX + this.ballWidth) {
                        this.ballY -= 2;
                        // Check which section of paddle

                        short paddleSectionLength = (short) (VectorBreakout.currentPaddles[i].paddleWidth / 4);
                        
                        // If on left edge
                        if (this.ballX + this.ballWidth < VectorBreakout.currentPaddles[i].paddleX + paddleSectionLength) {
                            this.bounce((byte) 2);
                        }
                        // If on right edge
                        else if (this.ballX > VectorBreakout.currentPaddles[i].paddleX + (paddleSectionLength * 3)) {
                            this.bounce((byte) 3);
                        }
                        // Center
                        else {
                            this.bounce((byte) 0);
                        }
                        
                        // Draw particles
                        byte ballParticleGen = 0;
                        for (byte ii = 0; ii < VectorBreakout.currentParticles.length; ii++) {
                            if (VectorBreakout.currentParticles[ii] == null) {
                                ballParticleGen++;
                                switch(ballParticleGen) {
                                    case 1:
                                        VectorBreakout.currentParticles[ii] = new Particle(0, this.ballX, this.ballY - 10, 0, -2, 15, 2, 7, 3);
                                        VectorBreakout.currentParticles[ii].spawn(5);
                                        break;
                                    case 2:
                                        VectorBreakout.currentParticles[ii] = new Particle(0, this.ballX - 3, this.ballY - 10, -2, -4, 15, 2, 6, 3);
                                        VectorBreakout.currentParticles[ii].spawn(5);
                                        break;
                                    case 3:
                                        VectorBreakout.currentParticles[ii] = new Particle(0, this.ballX + 10, this.ballY - 10, 2, -4, 15, 2, 8, 3);
                                        VectorBreakout.currentParticles[ii].spawn(5);
                                        break;
                                }
                                if (ballParticleGen < 3) {continue;}
                                else {return;}
                            }
                        }
                        
                        return;
                    }
                }
            }
        }
    }
    
}
