package dev.boyfailure.quajra.vectorbreakout;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import javax.swing.JComponent;
import java.awt.geom.Line2D;

public class GameDisplay extends JComponent {
    
    float beamX = 0; // Horizontal location of "vector beam"
    float beamY = 0; // Vertical location of "vector beam"
    
    // Change this to 1 if you build for older versions of Java. Older versions
    // will render a leading zero otherwise. (tested on JDK 1.5)
    byte iStart = 0;
    
    public static float beamScaleX = 1; // Horizontal drawing scale
    public static float beamScaleY = 1; // Vertical drawing scale
    public static float beamThicknessScale = 1; // Thickness of lines
    
    public void paint(Graphics gameGraphics) {
        
        super.paint(gameGraphics);
        
        Graphics2D g2 = (Graphics2D) gameGraphics;
        
        g2.setColor(Color.white);
        
        /**
         * Note on rendering numbers:
         * 
         * I am aware that I could be using a switch statement for these.
         * However, this did not compile when testing in JDK 1.5, as it would
         * refuse to accept anything other than numbers in a switch statement.
         * Since I am a silly little nerd who wishes to use this on my older
         * systems, I used these goofy if/else statements so I could compile
         * on the older JDKs and play on my older systems...
         */
        
        // Score
        resetBeam();
        moveBeam(20, -13);
        g2.setStroke(bt(2));
        String numToString = String.valueOf(VectorBreakout.score);
        String[] numToRender = numToString.split("");
        for (byte i = iStart; i < numToRender.length; i++) {
            if ("1".equals(numToRender[i])) {moveBeam(13, 0);g2.draw(drawVec(0, -24));moveBeam(5, 24);}
            else if ("2".equals(numToRender[i])) {moveBeam(0, -24);g2.draw(drawVec(14, 0));g2.draw(drawVec(0, 12));g2.draw(drawVec(-14, 0));g2.draw(drawVec(0, 12));g2.draw(drawVec(14, 0));moveBeam(4, 0);}
            else if ("3".equals(numToRender[i])) {moveBeam(0, -24);g2.draw(drawVec(14, 0));g2.draw(drawVec(0, 12));g2.draw(drawVec(-14, 0));moveBeam(14, 0);g2.draw(drawVec(0, 12));g2.draw(drawVec(-14, 0));moveBeam(18, 0);}
            else if ("4".equals(numToRender[i])) {moveBeam(0, -24);g2.draw(drawVec(0, 12));g2.draw(drawVec(14, 0));moveBeam(0, -12);g2.draw(drawVec(0, 24));moveBeam(4, 0);}
            else if ("5".equals(numToRender[i])) {moveBeam(14, -24);g2.draw(drawVec(-14, 0));g2.draw(drawVec(0, 12));g2.draw(drawVec(14, 0));g2.draw(drawVec(0, 12));g2.draw(drawVec(-14, 0));moveBeam(18, 0);}
            else if ("6".equals(numToRender[i])) {moveBeam(0, -24);g2.draw(drawVec(0, 24));g2.draw(drawVec(14, 0));g2.draw(drawVec(0, -12));g2.draw(drawVec(-14, 0));moveBeam(18, 12);}
            else if ("7".equals(numToRender[i])) {moveBeam(0, -24);g2.draw(drawVec(14, 0));g2.draw(drawVec(0, 24));moveBeam(4, 0);}
            else if ("8".equals(numToRender[i])) {g2.draw(drawVec(0, -24));g2.draw(drawVec(14, 0));g2.draw(drawVec(0, 24));g2.draw(drawVec(-14, 0));moveBeam(0, -12);g2.draw(drawVec(14, 0));moveBeam(4, 12);}
            else if ("9".equals(numToRender[i])) {moveBeam(14, 0);g2.draw(drawVec(0, -24));g2.draw(drawVec(-14, 0));g2.draw(drawVec(0, 12));g2.draw(drawVec(14, 0));moveBeam(4, 12);}
            else {g2.draw(drawVec(14, 0));g2.draw(drawVec(0, -24));g2.draw(drawVec(-14, 0));g2.draw(drawVec(0, 24));moveBeam(18, 0);}
        }
        
        // Lives
        resetBeam();
        moveBeam(200, -13);
        numToString = String.valueOf(VectorBreakout.lives);
        numToRender = numToString.split("");
        for (byte i = iStart; i < numToRender.length; i++) {
            if ("1".equals(numToRender[i])) {moveBeam(13, 0);g2.draw(drawVec(0, -24));moveBeam(5, 24);}
            else if ("2".equals(numToRender[i])) {moveBeam(0, -24);g2.draw(drawVec(14, 0));g2.draw(drawVec(0, 12));g2.draw(drawVec(-14, 0));g2.draw(drawVec(0, 12));g2.draw(drawVec(14, 0));moveBeam(4, 0);}
            else if ("3".equals(numToRender[i])) {moveBeam(0, -24);g2.draw(drawVec(14, 0));g2.draw(drawVec(0, 12));g2.draw(drawVec(-14, 0));moveBeam(14, 0);g2.draw(drawVec(0, 12));g2.draw(drawVec(-14, 0));moveBeam(18, 0);}
            else if ("4".equals(numToRender[i])) {moveBeam(0, -24);g2.draw(drawVec(0, 12));g2.draw(drawVec(14, 0));moveBeam(0, -12);g2.draw(drawVec(0, 24));moveBeam(4, 0);}
            else if ("5".equals(numToRender[i])) {moveBeam(14, -24);g2.draw(drawVec(-14, 0));g2.draw(drawVec(0, 12));g2.draw(drawVec(14, 0));g2.draw(drawVec(0, 12));g2.draw(drawVec(-14, 0));moveBeam(18, 0);}
            else if ("6".equals(numToRender[i])) {moveBeam(0, -24);g2.draw(drawVec(0, 24));g2.draw(drawVec(14, 0));g2.draw(drawVec(0, -12));g2.draw(drawVec(-14, 0));moveBeam(18, 12);}
            else if ("7".equals(numToRender[i])) {moveBeam(0, -24);g2.draw(drawVec(14, 0));g2.draw(drawVec(0, 24));moveBeam(4, 0);}
            else if ("8".equals(numToRender[i])) {g2.draw(drawVec(0, -24));g2.draw(drawVec(14, 0));g2.draw(drawVec(0, 24));g2.draw(drawVec(-14, 0));moveBeam(0, -12);g2.draw(drawVec(14, 0));moveBeam(4, 12);}
            else if ("9".equals(numToRender[i])) {moveBeam(14, 0);g2.draw(drawVec(0, -24));g2.draw(drawVec(-14, 0));g2.draw(drawVec(0, 12));g2.draw(drawVec(14, 0));moveBeam(4, 12);}
            else {g2.draw(drawVec(14, 0));g2.draw(drawVec(0, -24));g2.draw(drawVec(-14, 0));g2.draw(drawVec(0, 24));moveBeam(18, 0);}
        }
        
        // Level
        resetBeam();
        moveBeam(380, -13);
        numToString = String.valueOf(VectorBreakout.level);
        numToRender = numToString.split("");
        for (byte i = iStart; i < numToRender.length; i++) {
            if ("1".equals(numToRender[i])) {moveBeam(13, 0);g2.draw(drawVec(0, -24));moveBeam(5, 24);}
            else if ("2".equals(numToRender[i])) {moveBeam(0, -24);g2.draw(drawVec(14, 0));g2.draw(drawVec(0, 12));g2.draw(drawVec(-14, 0));g2.draw(drawVec(0, 12));g2.draw(drawVec(14, 0));moveBeam(4, 0);}
            else if ("3".equals(numToRender[i])) {moveBeam(0, -24);g2.draw(drawVec(14, 0));g2.draw(drawVec(0, 12));g2.draw(drawVec(-14, 0));moveBeam(14, 0);g2.draw(drawVec(0, 12));g2.draw(drawVec(-14, 0));moveBeam(18, 0);}
            else if ("4".equals(numToRender[i])) {moveBeam(0, -24);g2.draw(drawVec(0, 12));g2.draw(drawVec(14, 0));moveBeam(0, -12);g2.draw(drawVec(0, 24));moveBeam(4, 0);}
            else if ("5".equals(numToRender[i])) {moveBeam(14, -24);g2.draw(drawVec(-14, 0));g2.draw(drawVec(0, 12));g2.draw(drawVec(14, 0));g2.draw(drawVec(0, 12));g2.draw(drawVec(-14, 0));moveBeam(18, 0);}
            else if ("6".equals(numToRender[i])) {moveBeam(0, -24);g2.draw(drawVec(0, 24));g2.draw(drawVec(14, 0));g2.draw(drawVec(0, -12));g2.draw(drawVec(-14, 0));moveBeam(18, 12);}
            else if ("7".equals(numToRender[i])) {moveBeam(0, -24);g2.draw(drawVec(14, 0));g2.draw(drawVec(0, 24));moveBeam(4, 0);}
            else if ("8".equals(numToRender[i])) {g2.draw(drawVec(0, -24));g2.draw(drawVec(14, 0));g2.draw(drawVec(0, 24));g2.draw(drawVec(-14, 0));moveBeam(0, -12);g2.draw(drawVec(14, 0));moveBeam(4, 12);}
            else if ("9".equals(numToRender[i])) {moveBeam(14, 0);g2.draw(drawVec(0, -24));g2.draw(drawVec(-14, 0));g2.draw(drawVec(0, 12));g2.draw(drawVec(14, 0));moveBeam(4, 12);}
            else {g2.draw(drawVec(14, 0));g2.draw(drawVec(0, -24));g2.draw(drawVec(-14, 0));g2.draw(drawVec(0, 24));moveBeam(18, 0);}
        }
        
        // Walls
        g2.setColor(Color.gray);
        g2.setStroke(bt(10));
        resetBeam();
        moveBeam(15, 0);
        g2.draw(drawVec(0, 600));
        moveBeam(770, 0);
        g2.draw(drawVec(0, -600));
        moveBeam(15, -5);
        g2.draw(drawVec(-800, 0));
        
        // Bricks
        if (VectorBreakout.currentLevel != null) {
            for (byte i = 0; i < VectorBreakout.currentLevel.levelBricks.length; i++) {
                if (VectorBreakout.currentLevel.levelBricks[i] != null) {
                    if (VectorBreakout.currentLevel.levelBricks[i].isBroken == false) {
                        resetBeam();
                        g2.setStroke(bt(3));
                        moveBeam(VectorBreakout.currentLevel.levelBricks[i].brickX + 1, VectorBreakout.currentLevel.levelBricks[i].brickY + 1);
                        g2.setColor(vc(VectorBreakout.currentLevel.levelBricks[i].brickColor));
                        g2.draw(drawVec(VectorBreakout.currentLevel.levelBricks[i].brickWidth - 2, 0));
                        g2.draw(drawVec(0, -(VectorBreakout.currentLevel.levelBricks[i].brickHeight - 2)));
                        g2.draw(drawVec(-(VectorBreakout.currentLevel.levelBricks[i].brickWidth - 2), 0));
                        g2.draw(drawVec(0, VectorBreakout.currentLevel.levelBricks[i].brickHeight - 2));
                    }
                }
            }
        }
        
        // Paddles
        g2.setColor(Color.white);
        for (byte i = 0; i < VectorBreakout.currentPaddles.length; i++) {
            if (VectorBreakout.currentPaddles[i] != null) {
                if (VectorBreakout.currentPaddles[i].isActive) {
                    resetBeam();
                    g2.setStroke(bt(3));
                    moveBeam(VectorBreakout.currentPaddles[i].paddleX, VectorBreakout.currentPaddles[i].paddleY);
                    g2.draw(drawVec(VectorBreakout.currentPaddles[i].paddleWidth, 0));
                    g2.draw(drawVec(0, -(VectorBreakout.currentPaddles[i].paddleHeight)));
                    g2.draw(drawVec(-(VectorBreakout.currentPaddles[i].paddleWidth), 0));
                    g2.draw(drawVec(0, VectorBreakout.currentPaddles[i].paddleHeight));
                }
            }
        }
        
        // Balls
        g2.setStroke(bt(3));
        g2.setColor(Color.yellow);
        for (byte i = 0; i < VectorBreakout.currentBalls.length; i++) {
            if (VectorBreakout.currentBalls[i] != null) {
                if (VectorBreakout.currentBalls[i].isActive) {
                    resetBeam();
                    moveBeam(VectorBreakout.currentBalls[i].ballX, VectorBreakout.currentBalls[i].ballY);
                    g2.draw(drawVec(VectorBreakout.currentBalls[i].ballWidth, 0));
                    g2.draw(drawVec(0, VectorBreakout.currentBalls[i].ballHeight));
                    g2.draw(drawVec(-VectorBreakout.currentBalls[i].ballWidth, 0));
                    g2.draw(drawVec(0, -VectorBreakout.currentBalls[i].ballHeight));
                }
            }
        }
        
        // Particles (still experimenting with these! rendering disabled for now...)
        /*
        for (byte i = 0; i < VectorBreakout.currentParticles.length; i++) {
            if (VectorBreakout.currentParticles[i] != null) {
                if (VectorBreakout.currentParticles[i].isActive) {
                    resetBeam();
                    moveBeam(VectorBreakout.currentParticles[i].particleX, VectorBreakout.currentParticles[i].particleY);
                    g2.setStroke(bt(VectorBreakout.currentParticles[i].vectorScale));
                    g2.setColor(vc(VectorBreakout.currentParticles[i].particleColor));
                    g2.draw(drawVec(VectorBreakout.currentParticles[i].particleX2, VectorBreakout.currentParticles[i].particleY2));
                }
            }
        }
        */
        
        // Paused
        g2.setStroke(bt(3));
        if (VectorBreakout.isPaused) {
            g2.setColor(Color.white);
            resetBeam();
            moveBeam(110, 260);
            // P
            g2.draw(drawVec(0, -110));g2.draw(drawVec(80, 0));g2.draw(drawVec(0, 50));g2.draw(drawVec(-80, 0));
            moveBeam(100, 60);
            // A
            g2.draw(drawVec(0, -70));g2.draw(drawVec(40, -40));g2.draw(drawVec(40, 40));g2.draw(drawVec(0, 70));g2.draw(drawVec(0, -40));g2.draw(drawVec(-80, 0));
            moveBeam(100, 40);
            // U
            moveBeam(0, -110);g2.draw(drawVec(0, 110));g2.draw(drawVec(80, 0));g2.draw(drawVec(0, -110));
            moveBeam(20, 110);
            // S
            g2.draw(drawVec(80, 0));g2.draw(drawVec(0, -55));g2.draw(drawVec(-80, 0));g2.draw(drawVec(0, -55));g2.draw(drawVec(80, 0));
            moveBeam(20, 110);
            // E
            moveBeam(80, 0);g2.draw(drawVec(-80, 0));g2.draw(drawVec(0, -55));g2.draw(drawVec(80, 0));moveBeam(-80, 0);g2.draw(drawVec(0, -55));g2.draw(drawVec(80, 0));
            moveBeam(20, 110);
            // D
            g2.draw(drawVec(40, 0));g2.draw(drawVec(40, -40));g2.draw(drawVec(0, -30));g2.draw(drawVec(-40, -40));g2.draw(drawVec(-40, 0));g2.draw(drawVec(0, 110));
            moveBeam(100, 110);
        }
        
        VectorBreakout.actualFrames++; // Count up actual frames rendered
        
        // Debug Menu
        if (VectorBreakout.debugMenuEnabled) {
            g2.setColor(Color.white);
            g2.drawString("Quajra Debug", 1, 12);
            g2.drawString("frame: " + VectorBreakout.frameCounter, 1, 24);
            g2.drawString("beamScaleX: " + beamScaleX, 1, 36);
            g2.drawString("beamScaleY: " + beamScaleY, 1, 48);
            g2.drawString("isPaused: " + VectorBreakout.isPaused, 1, 60);
            g2.drawString("targetFrameRate: " + VectorBreakout.targetFrameRate, 150, 24);
            g2.drawString("actualFrameRate: " + VectorBreakout.actualFrameRate, 150, 36);
            g2.drawString("actualFrames: " + VectorBreakout.actualFrames, 150, 48);
            g2.drawString("chancey: " + VectorBreakout.chancey, 150, 60);
            g2.drawString("ballsOnScreen: " + VectorBreakout.ballsOnScreen, 300, 24);
        }
        
    }
    
    public Line2D.Float drawVec(float x, float y) {
        float oldBeamX = beamX;
        float oldBeamY = beamY;
        beamX += (x * beamScaleX);
        beamY += (y * beamScaleY);
        return new Line2D.Float(oldBeamX, oldBeamY, beamX, beamY);
    }
    
    public Color vc(int col) {
        switch ((byte) col) {
            case 0: return Color.red;
            case 1: return Color.getHSBColor(25, 258, 77);
            case 2: return Color.cyan;
            case 3: return Color.green;
            case 4: return Color.magenta;
            case 5: return Color.yellow;
            case 15: return Color.white;
            default: return Color.gray;
        }
    }
    
    public BasicStroke bt(float size) {
        return new BasicStroke(size * beamThicknessScale);
    }
    
    public void moveBeam(float x, float y) {
        beamX += (x * beamScaleX);
        beamY += (y * beamScaleY);
    }
    
    public void resetBeam() {
        beamX = 0;
        beamY = 40 * beamScaleY;
    }
    
    public GameDisplay() {
    }
    
    /*  For later use
        // A
        g2.draw(drawVec(0, -70));
        g2.draw(drawVec(40, -40));
        g2.draw(drawVec(40, 40));
        g2.draw(drawVec(0, 70));
        g2.draw(drawVec(0, -40));
        g2.draw(drawVec(-80, 0));
        moveBeam(100, 40);
        
        // B
        g2.draw(drawVec(0, -110));
        g2.draw(drawVec(60, 0));
        g2.draw(drawVec(20, (float) 18.333));
        g2.draw(drawVec(0, (float) 18.333));
        g2.draw(drawVec(-20, (float) 18.333));
        g2.draw(drawVec(-60, 0));
        g2.draw(drawVec(60, 0));
        g2.draw(drawVec(20, (float) 18.333));
        g2.draw(drawVec(0, (float) 18.333));
        g2.draw(drawVec(-20, (float) 18.333));
        g2.draw(drawVec(-60, 0));
        moveBeam(100, 0);
        
        // C
        moveBeam(80, -110);
        g2.draw(drawVec(-80, 0));
        g2.draw(drawVec(0, 110));
        g2.draw(drawVec(80, 0));
        moveBeam(20, 0);
        
        // D
        g2.draw(drawVec(40, 0));
        g2.draw(drawVec(40, -40));
        g2.draw(drawVec(0, -30));
        g2.draw(drawVec(-40, -40));
        g2.draw(drawVec(-40, 0));
        g2.draw(drawVec(0, 110));
        moveBeam(100, 110);
        
        // E
        moveBeam(80, -110);
        g2.draw(drawVec(-80, 0));
        g2.draw(drawVec(0, -55));
        g2.draw(drawVec(80, 0));
        moveBeam(-80, 0);
        g2.draw(drawVec(0, -55));
        g2.draw(drawVec(80, 0));
        moveBeam(20, 0);
        
        // F
        g2.draw(drawVec(0, 110));
        moveBeam(0, -110);
        g2.draw(drawVec(80, 0));
        moveBeam(-80, 50);
        g2.draw(drawVec(80, 0));
        moveBeam(10, 60);
     
     
        // P
        g2.draw(drawVec(0, -110));
        g2.draw(drawVec(80, 0));
        g2.draw(drawVec(0, 50));
        g2.draw(drawVec(-80, 0));
        moveBeam(100, 60);
        // A
        g2.draw(drawVec(0, -70));
        g2.draw(drawVec(40, -40));
        g2.draw(drawVec(40, 40));
        g2.draw(drawVec(0, 70));
        g2.draw(drawVec(0, -40));
        g2.draw(drawVec(-80, 0));
        moveBeam(100, 40);
        // U
        moveBeam(0, -110);
        g2.draw(drawVec(0, 110));
        g2.draw(drawVec(80, 0));
        g2.draw(drawVec(0, -110));
        moveBeam(20, 110);
        // S
        g2.draw(drawVec(80, 0));
        g2.draw(drawVec(0, -55));
        g2.draw(drawVec(-80, 0));
        g2.draw(drawVec(0, -55));
        g2.draw(drawVec(80, 0));
        moveBeam(20, -110);
     
        */
    
}
