package dev.boyfailure.quajra.vectorbreakout;

public class Level {
    
    short levelID;
    String levelName = "Level";
    byte[] levelLayout; // 19 bricks per row
    Brick[] levelBricks;
    
    public Level(int id) {
        this.levelID = (short) id;
        
        switch(id) {
            case 1:
                this.levelName = "Test";
                levelLayout = new byte[]
                {4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
                 3,3,3,3,3,5,3,3,3,3,3,3,3,5,3,3,3,3,3,
                 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
                 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
                break;
            case 2:
                this.levelName = "waow (based)";
                levelLayout = new byte[]
                {4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,
                 3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,
                 2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,
                 1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3};
                break;
            case 3:
                this.levelName = "HOLES";
                levelLayout = new byte[]
                {4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
                 3,3,0,0,3,3,3,3,0,0,0,3,3,3,3,0,0,3,3,
                 2,2,0,0,2,2,2,2,0,0,0,2,2,2,2,0,0,2,2,
                 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
                break;
            default:
                this.levelName = "Level " + levelID;
                levelLayout = new byte[]
                {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
                 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
                 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
                 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
                break;
        }
        
    }
    
    public void startLevel() {
        // Brick placement
        short brickLeftPlacement = 20;
        if (this.levelLayout != null) {
            this.levelBricks = new Brick[this.levelLayout.length];
            for (int i = 0; i < this.levelLayout.length; i++) {
                switch (this.levelLayout[i]) {
                    case 1:
                        this.levelBricks[i] = new Brick(brickLeftPlacement, (((int) (i / 19)) * 20) + 50, false, 3, 4, 0);
                        break;
                    case 2:
                        this.levelBricks[i] = new Brick(brickLeftPlacement, (((int) (i / 19)) * 20) + 50, false, 2, 8, 0);
                        break;
                    case 3:
                        this.levelBricks[i] = new Brick(brickLeftPlacement, (((int) (i / 19)) * 20) + 50, false, 1, 16, 0);
                        break;
                    case 4:
                        this.levelBricks[i] = new Brick(brickLeftPlacement, (((int) (i / 19)) * 20) + 50, false, 0, 32, 0);
                        break;
                    case 5:
                        this.levelBricks[i] = new Brick(brickLeftPlacement, (((int) (i / 19)) * 20) + 50, false, 4, 8, 2);
                        break;
                    default:
                        this.levelBricks[i] = null;
                        break;
                }
                brickLeftPlacement += 40;
                if (brickLeftPlacement >= 760) {brickLeftPlacement = 20;}
            }
        }
        VectorBreakout.bricksOnScreen = (short) this.levelBricks.length;
        
    }
    
}
