package dev.boyfailure.quajra.vectorbreakout;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import javax.swing.JFrame;
import javax.swing.Timer;

public class VectorBreakout {
    
    public static String gameName = "Vector Breakout";
    public static boolean isGameStarted = false;
    public static boolean isPaused = false;
    public static boolean debugMenuEnabled = false;
    public static boolean isLost = false;
    public static short gameResX = 800;
    public static short gameResY = 600;
    public static byte lives = 5;
    public static byte chancey = 0;
    public static short level = 1;
    public static byte ballsOnScreen = 0;
    public static short bricksOnScreen = 0;
    public static byte targetFrameRate = 60;
    public static byte actualFrames = 0;
    public static byte actualFrameRate = 0;
    public static byte gameTickRate = 60;
    public static int score = 0;
    public static long frameCounter = 0;
    public static boolean movingLeft = false;
    public static boolean movingRight = false;
    public static Ball[] currentBalls = new Ball[10];
    public static Particle[] currentParticles = new Particle[63];
    public static Paddle[] currentPaddles = {new Paddle(350, 500, 100, 15, 0, 1)};
    public static Level currentLevel;

    public VectorBreakout() {
    }
    
    public static void main(String[] args) {
        System.setProperty("sun.java2d.opengl", "true");
        final JFrame gameFrame = new JFrame();
        
        gameFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        gameFrame.setTitle(gameName);
        gameFrame.setSize(gameResX, gameResY);
        gameFrame.getContentPane().setBackground(Color.black);
        
        final GameDisplay gameCanvas = new GameDisplay();
        gameFrame.getContentPane().add(gameCanvas);
        
        gameFrame.setVisible(true);
        
        gameFrame.addKeyListener(new KeyListener() {
            public void keyPressed(KeyEvent e) {
                switch(e.getKeyCode()) {
                    case 27: // Escape
                        debugMenuEnabled = !debugMenuEnabled;
                        break;
                    case 10: // Enter
                        if (isGameStarted) {isPaused = !isPaused;}
                        break;
                    case 32: // Space
                        if (isLost || !isGameStarted) {isGameStarted = true;newGame();return;}
                        if (!isPaused) {
                            if (ballsOnScreen < 1) {
                                for (byte i = 0; i < currentBalls.length; i++) {
                                    if (currentBalls[i] == null) {
                                        currentBalls[i] = new Ball(200, 300, 7, 7, 0, true);
                                        currentBalls[i].spawnBall(true);
                                        return;
                                    }
                                }
                            }
                        }
                        break;
                    case 37: // Left
                        if (isGameStarted) {movingLeft = true;}
                        break;
                    case 39: // Right
                        if (isGameStarted) {movingRight = true;}
                        break;
                }
            }
            public void keyReleased(KeyEvent e) {
                switch(e.getKeyCode()) {
                    case 37: // Left
                        movingLeft = false;
                        break;
                    case 39: // Right
                        movingRight = false;
                        break;
                }
            }
            public void keyTyped(KeyEvent e) {}
        });
        
        // Adapts vector drawing scale when the window is resized 
        gameFrame.addComponentListener(new ComponentAdapter() {
            public void componentResized(ComponentEvent componentEvent) {
                gameCanvas.beamScaleX = gameFrame.getBounds().width / 800f;
                gameCanvas.beamScaleY = gameFrame.getBounds().height / 600f;
                if (gameCanvas.beamScaleX <= gameCanvas.beamScaleY) {gameCanvas.beamThicknessScale = gameCanvas.beamScaleX;}
                else {gameCanvas.beamThicknessScale = gameCanvas.beamScaleY;}
            }
        });
        
        Timer gameTick = new Timer((1000 / gameTickRate), new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                onGameTick();
            }
        });
        gameTick.start();
        
        Timer frameDisplay = new Timer((1000 / targetFrameRate), new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                frameCounter++;
                gameFrame.repaint();
            }
        });
        frameDisplay.start();

        Timer gameCuller = new Timer(1000, new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                actualFrameRate = actualFrames;
                actualFrames = 0;
                if (currentLevel != null) {
                    for (byte i = 0; i < currentLevel.levelBricks.length; i++) {
                        if (currentLevel.levelBricks[i] != null) {
                            if (currentLevel.levelBricks[i].isBroken) {
                                currentLevel.levelBricks[i] = null;
                            }
                        }
                    }
                }
                for (byte i = 0; i < currentBalls.length; i++) {
                    if (currentBalls[i] != null) {
                        if (currentBalls[i].isActive == false) {
                            currentBalls[i] = null;
                        }
                    }
                }
                for (byte i = 0; i < currentParticles.length; i++) {
                    if (currentParticles[i] != null) {
                        if (currentParticles[i].isActive == false) {
                            currentParticles[i] = null;
                        }
                    }
                }
                if (bricksOnScreen <= 0 && isGameStarted) {
                    level++;
                    currentLevel = new Level(level);
                    currentLevel.startLevel();
                }
            }
        });
        gameCuller.start();
    }
    
    
    public static void onGameTick() {
        // i will implement something better than "chancey" eventually
        chancey++;
        if (chancey >= 16) {
            chancey = 0;
        }
        
        if (isPaused) {return;}
        
        // Move player if keys are held
        for (byte i = 0; i < currentPaddles.length; i++) {
            if (currentPaddles[i] != null) {
                if (movingLeft) {
                    currentPaddles[i].movePaddle(false);
                }
                else if (movingRight) {
                    currentPaddles[i].movePaddle(true);
                }
                else {
                    currentPaddles[i].paddleSpeed = 0;
                }
            }
        }
        
        // Ball logic (movement, collision checks)
        for (byte i = 0; i < currentBalls.length; i++) {
            if (currentBalls[i] != null) {
                if (currentBalls[i].isActive) {
                    currentBalls[i].moveBall();
                }
            }
        }
        
        // Particles
        for (byte i = 0; i < currentParticles.length; i++) {
            if (currentParticles[i] != null) {
                if (currentParticles[i].isActive) {
                    currentParticles[i].update();
                }
            }
        }
    }
    
    
    public static void gameLose() {
        if (currentLevel != null) {
            for (byte i = 0; i < currentLevel.levelBricks.length; i++) {
                currentLevel.levelBricks[i] = null;
            }
        }
        for (byte i = 0; i < currentBalls.length; i++) {
            currentBalls[i] = null;
        }
        isLost = true;
        ballsOnScreen = 0;
    }
    
    public static void newGame() {
        lives = 5;
        isLost = false;
        score = 0;
        level = 1;
        frameCounter = 0;
        ballsOnScreen = 0;
        movingLeft = false;
        movingRight = false;
        currentPaddles[0] = new Paddle(350, 500, 100, 15, 0, 1);
        //test currentPaddles[0] = new Paddle(0, 500, 800, 60, 0, 1);
        currentLevel = new Level(level);
        currentLevel.startLevel();
    }
}
